BigTermRecorder Class Reference

BigTermRecorder records all the terms it consumes into an ideal. More...

`#include <BigTermRecorder.h>`

Inheritance diagram for BigTermRecorder:

## Public Member Functions

| BigTermRecorder ()
virtual void | consumeRing (const VarNames &names)
| Tell the consumer which ring is being used.
virtual void | beginConsuming ()
| Tell the consumer to begin consuming an ideal.
virtual void | consume (const Term &term, const TermTranslator &translator)
virtual void | consume (const vector< mpz_class > &term)
virtual void | doneConsuming ()
| Must be called once after each time beginConsuming has been called.
virtual void | consume (unique_ptr< BigIdeal > ideal)
bool | empty () const
unique_ptr< BigIdeal > | releaseIdeal ()
const VarNames & | getRing ()
Public Member Functions inherited from BigTermConsumer
virtual | ~BigTermConsumer ()
virtual void | consume (const Term &term)
| Consume a term.
virtual void | consume (const BigIdeal &ideal)
void | beginConsuming (const VarNames &names)
Public Member Functions inherited from TermConsumer
virtual | ~TermConsumer ()
virtual void | beginConsumingList ()
| Tell the consumer that the ideals that are consumed until the next call to doneConsumingList are to be considered as one list of ideals, rather than as a number of separate ideals.
virtual void | doneConsumingList ()
| Must be called once after each time beginConsumingList has been called.
void | consume (const Ideal &ideal)
| This is a non-virtual utility method that calls the other methods to achieve its effect of calling beginConsuming, then consuming all generators, and then calling doneConsuming.

## Private Attributes

VarNames | _names
size_t | _idealCount
list< BigIdeal * > | _ideals
ElementDeleter< list< BigIdeal * > > | _idealsDeleter

## Detailed Description

BigTermRecorder records all the terms it consumes into an ideal.

Definition at line 31 of file BigTermRecorder.h.

## Constructor & Destructor Documentation

## BigTermRecorder()

BigTermRecorder::BigTermRecorder | ( |  | ) |

Definition at line 24 of file BigTermRecorder.cpp.

## Member Function Documentation

## beginConsuming()

void BigTermRecorder::beginConsuming | ( |  | ) |

virtual

Tell the consumer to begin consuming an ideal.

It is required to call this method before calling consume().

Implements BigTermConsumer.

Definition at line 38 of file BigTermRecorder.cpp.

## consume() [1/3]

void BigTermRecorder::consume | ( | const Term & | term,
|  | const TermTranslator & | translator )

virtual

Implements BigTermConsumer.

Definition at line 43 of file BigTermRecorder.cpp.

## consume() [2/3]

void BigTermRecorder::consume | ( | const vector< mpz_class > & | term | ) |

virtual

Implements BigTermConsumer.

Definition at line 57 of file BigTermRecorder.cpp.

## consume() [3/3]

void BigTermRecorder::consume | ( | unique_ptr< BigIdeal > | ideal | ) |

virtual

Reimplemented from BigTermConsumer.

Definition at line 33 of file BigTermRecorder.cpp.

## consumeRing()

void BigTermRecorder::consumeRing | ( | const VarNames & | names | ) |

virtual

Tell the consumer which ring is being used.

Implements BigTermConsumer.

Definition at line 29 of file BigTermRecorder.cpp.

## doneConsuming()

void BigTermRecorder::doneConsuming | ( |  | ) |

virtual

Must be called once after each time beginConsuming has been called.

Implements BigTermConsumer.

Definition at line 67 of file BigTermRecorder.cpp.

## empty()

bool BigTermRecorder::empty | ( |  | ) | const

Definition at line 70 of file BigTermRecorder.cpp.

## getRing()

const VarNames & BigTermRecorder::getRing | ( |  | ) |

Definition at line 81 of file BigTermRecorder.cpp.

## releaseIdeal()

unique_ptr< BigIdeal > BigTermRecorder::releaseIdeal | ( |  | ) |

Definition at line 74 of file BigTermRecorder.cpp.

## Member Data Documentation

## _idealCount

size_t BigTermRecorder::_idealCount

private

Definition at line 55 of file BigTermRecorder.h.

## _ideals

list<BigIdeal*> BigTermRecorder::_ideals

private

Definition at line 56 of file BigTermRecorder.h.

## _idealsDeleter

ElementDeleter<list<BigIdeal*> > BigTermRecorder::_idealsDeleter

private

Definition at line 57 of file BigTermRecorder.h.

## _names

VarNames BigTermRecorder::_names

private

Definition at line 54 of file BigTermRecorder.h.

The documentation for this class was generated from the following files:

- src/BigTermRecorder.h
- src/BigTermRecorder.cpp